
; PROGRAMME DE SIMULATION DE MOTO WOA BALEZE ! (c) MegaSoft Corp. v1

.386

CODE SEGMENT USE16
ASSUME cs:CODE
ORG 100h

Start:

;      **************************
;      INITIALISER L'ECRAN DE JEU
;      **************************

       mov ax,13h    ; Mode vido 13h (320x200 bbte)
       int 10h       ; et remplit la mmoire vido avec des zeros
       
       mov ax,0a000h ; ES = A000h  (mmoire vido)
       mov es,ax
       
       xor bx,bx     ; BX = 0
       mov cx,320    ; 320 points  tracer pour les bordures horizontales

CouleurCadre = 15    ; 15 est la couleur du bord

TraceBordsHorizontaux:

       mov byte ptr es:[bx],CouleurCadre       ; Trace le bord supprieur
       mov byte ptr es:[bx+63680],CouleurCadre ; et le bord infrieur
       inc bx
       loop TraceBordsHorizontaux
       
       xor bx,bx
       mov cx,200    ; 200 points pour les bordures verticales
       
TraceBordsVerticaux:

       mov byte ptr es:[bx],CouleurCadre     ; Bord gauche
       mov byte ptr es:[bx+319],CouleurCadre ; Bord droit
       add bx,320
       loop TraceBordsVerticaux
       
       
;      Maintenant la boucle principale commence

BigBoucle:

;      ******************************
;      VERIFIER LES COORDONNEES (X,Y)
;      ******************************

       movzx esi,Y          ; esi = Y  (>0)
       lea si,[esi+esi*4]   ; si = esi*5   ]  Au final : 
       shl si,6             ; si = si*64   ]  si = Y * 320
       add si,X             ; si = si+X  -> Ca y est, si = adresse du point
       
       cmp byte ptr es:[si],0    ; Y a t-il deja quelquechose ?
       jne Exit                  ; Si oui, alors c'est perdu

;      ***********************
;      AFFICHER LE POINT (X,Y)
;      ***********************

       mov byte ptr es:[si],2  ; 2 est la couleur de la moto
                               ; (pourquoi pas, hein ?)
                               
       mov dx,3dah
       in al,dx
       test al,8
       jnz $-3
       in al,dx
       test al,8
       jz $-3
       

;      **************************
;      LIRE UNE TOUCHE AU CLAVIER
;      **************************

       mov ah,1             ; Y a t-il une touche pour nous ?
       int 16h
       jz PasTouche         ; Sinon, tant pis, on repassera plus tard
       
       mov ah,0             ; Oui ?  Alors on la prend.
       int 16h
       
       cmp al,'i'           ; 'i' c'est pour monter
       jne PasI
       mov Xinc,0
       mov Yinc,-1
       jmp PasTouche
PasI:
       cmp al,'k'           ; 'k' c'est pour descendre
       jne PasK
       mov Xinc,0
       mov Yinc,1
       jmp PasTouche
PasK:
       cmp al,'j'           ; 'j' c'est pour aller  gauche
       jne PasJ
       mov Xinc,-1
       mov Yinc,0
       jmp PasTouche
PasJ:
       cmp al,'l'           ; 'l' c'est pour la droite
       jne PasTouche
       mov Xinc,1
       mov Yinc,0

PasTouche:

;      *********************
;      FAIRE AVANCER LA MOTO
;      *********************
       
       mov ax,Xinc
       add X,ax
       
       mov ax,Yinc
       add Y,ax
       
;      *******
;      BOUCLER
;      *******

       jmp BigBoucle
       
;      ****
;      EXIT
;      ****

Exit:

       mov ax,3h            ; mode video texte 80x25
       int 10h
       
       mov ah,4ch           ; Retour au DOS
       int 21h
       
;      *****
;      DATAS
;      *****

X      DW 30
Y      DW 100

Xinc   DW 1
Yinc   DW 0

Code ENDS

END Start

