;Disclaimer: L'utilisateur assume toute responsabilit quant  l'utilisation
;  de ce programme. Celui-ci est livr dans l'tat, et il ne saurait tre 
;  question de poursuites en cas de non fonctionnement, ou de prjudice moral
;  et/ou financier. Non mais !


.386

code segment 'code' use16
    assume cs:code,ds:code
    
    mov ax,cs
    mov ds,ax
    
    mov ah,03
    xor bh,bh  ;Page cran actuelle
    int 10h	;Lit la position du curseur
    	;Sortie -> dh=ligne , dl=colonne
    mov curseur,dx ;on sauve la position actuelle du curseur
    
    mov di,80h  ;DI pointe sur le nbr de chr dans la ligne de commande
    cmp byte ptr [ES:DI],0   ;[ES:di] obligatoire sinon pointe sur DS:di !
    je dir              ;pas de paramtres ? on commence le directory

    xor cx,cx   ;on n'est jamais trop prudent!
    mov cl, byte ptr [es:di]
    dec cl                ;pour ne pas copier le '0Dh' final
    
    mov di,82h  ;positionn aprs le chr 'espace'
search: cmp byte ptr [es:di],60
        jb @search 
        sub byte ptr [es:di],32
@search: cmp byte ptr [es:di],'P'             
        je pause_on
        cmp byte ptr [es:di],'S'
        je sucker_on	;Notez que le parser a t un peu amlior.	
        inc di
        loop search
        jmp show_help           ;huhuhu,le paramtre '?' ne sert  rien!

sucker_on: lea dx,sucker
           mov ah,09h
           int 21h
           jmp fin

pause_on: mov p,1
	mov ah,2
	xor bx,bx
	mov cx,0d0eh
	mov dx,1800h	;positionne en bas de l'cran
	int 10h	

dir: mov ah,1ah         ;fixe nouvelle adresse DTA
     lea dx,new_dta
     int 21h
     mov ax,0b800h
     mov es,ax
     
    mov dx,curseur
    shr dx,8	;on ne garde que les lignes en DL
    cmp dl,23	;on est en bas de l'cran ? (ligne 25)
    jg bottom
    inc dl	;ligne = ligne+1
    
 bottom:  mov ax,160	;Nbr d'octets par lignes
          mul dx
    
    mov di,ax	;DI = position actuelle d'criture dans la mmoire vido
    dec di
    
     mov ah,4eh         ;recherche la 1re entre du rpertoire
     mov cx,0ffh        ;on recherche tous les fichiers
     lea dx,file_search
     int 21h

show_file: cmp di,3840
           jb noscroll	;la 25me ligne n'est pas occupe	

	push ds

	push es
	pop ds
	mov si,160
	xor di,di
	mov cx,160*6	;160*24/4 (car Dwords)
	rep movsd	;Hop on recopie tout,une ligne plus haut

	dec di	;repositionnement dans le mot
	pop ds


noscroll:	lea si,new_dta+30    ;emplacement du nom du fichier dans la DTA
           	mov al,07 ;attribut
           	mov cx,12
    write:	mov ah,byte ptr [si]
    	stosw
    	inc si
    	loop write
           add di,6
           
           
           mov ax,word ptr [new_dta+28]  ;Mot fort de la taille de fichier
           call show_nombre
           add di,8
           mov ax,word ptr [new_dta+26]  ;Mot faible (merci untel :( )
           call show_nombre


     add di,122  ; la ligne 
     
     lea si,new_dta+31  ;Ces 5 instructions servent  viter que certains
     xor eax,eax	;noms de fichiers trop longs empitent sur		
     mov dword ptr [si],eax   ;le nom de fichier suivant
     mov dword ptr [si+4],eax	;(un fichier=une lettre minimum)
     mov dword ptr [si+8],eax ;et vivement le 128 bits ! Warf warf!!
     
     cmp p,0
     je suite ;pause_off
     inc p
     cmp p,24
     jne suite
     mov p,1
     lea dx,pause
     mov ah,09h
     int 21h
     mov ah,00h
     int 16h    ;ah=00,int 16h = attends une frappe

suite: inc octet
       mov ah,4fh       ;recherche la prochaine entre du rpertoire
       int 21h
       jnc show_file
       jmp fin

show_help: lea dx,help
           mov ah,09
           int 21h

fin:  mov dx,curseur
      add dh,octet
      cmp dh,24
      jb @fin
      mov dh,24
      
  @fin: xor bx,bx
        mov ah,2
        mov cx,0D0Eh
        int 10h
      


  mov ax,4c00h
  int 21h     ;Et c'est vraiment la fin !

show_nombre     proc
                mov bx,ax ;sauve
                shr ah,4  ;on commence par la partie 'high' du registre
                add ah,48 ;convertit ascii
                cmp ah,58 ;compris entre 0 et 9 ?
                jb n4     ; OUI -> affiche directement
                add ah,7  ; NON -> correction pour transformer AH en lettre
           n4:  mov dl,ah
                mov byte ptr [es:di+1],ah
                
                mov ah,bh
                and ah,0fh
                add ah,48
                cmp ah,58
                jb n3
                add ah,7
           n3:  mov dl,ah
                mov byte ptr [es:di+3],ah
                
                shr al,4        ;On s'occupe maintenant de la partie 'low'
                add al,48
                cmp al,58
                jb n2
                add al,7
           n2:  mov dl,al
                mov byte ptr [es:di+5],al
                
                mov al,bl
                and al,0fh
                add al,48
                cmp al,58
                jb n1
                add al,7
           n1:  mov dl,al
                mov byte ptr [es:di+7],al
                ret
show_nombre endp
    



help  db 10,13,'ZDIR 2.0 par Warrant',10,13
      db 'Usage: ZDIR <paramtres>',10,13
      db '        /? : Affiche l',39,'aide',10,13
      db '        /P : Pause  chaque page',10,13  
      db '        /S : Scroll en 16 millions de couleurs',10,13,'$'
P     db 0  ;Pause on=1
sucker db 'Fonction non implmente!',10,13,'$'
pause db '                   PAUSE. Appuyez sur une touche',10,13,'$'

curseur dw 0
octet db 0	; la longue,trouver des noms de variables, a devient chiant!

new_dta  db 128 dup (0) 
file_search db '*.*',0     ;recherche toutes les entres                     

code ends

end
