;Disclaimer: Comme d'habitude, je ne suis responsable de rien du tout si
;votre bcane vous pte  la gueule.

.386

code segment 'code' use16
    assume cs:code,ds:code
    
    mov ax,cs
    mov ds,ax
    

	 mov ax,0008h
	 mov dx,3d4h
	 out dx,al
	 inc dx
	 in al,dx
	 mov byte ptr [cs:origine],al

    mov ah,03
    xor bh,bh  ;Page cran actuelle
    int 10h     ;Lit la position du curseur
	;Sortie -> dh=ligne , dl=colonne
    mov curseur,dx ;on sauve la position actuelle du curseur
    

     mov ah,1ah         ;fixe nouvelle adresse DTA
     lea dx,new_dta
     int 21h
     mov ax,0b800h
     mov es,ax
     
    mov dx,curseur
    shr dx,8    ;on ne garde que les lignes en DL
    cmp dl,24   ;on est en dehors de l'cran ?
    jg bottom
    inc dl      ;ligne = ligne+1
    
 bottom:  mov ax,160    ;Nbr d'octets par lignes
	  mul dx
    
    mov di,ax   ;DI = position actuelle d'criture dans la mmoire vido
    dec di      ;on est de nouveau une ligne avant la dernire.
    
     mov ah,4eh         ;recherche la 1re entre du rpertoire
     mov cx,0ffh        ;on recherche tous les fichiers
     lea dx,file_search
     int 21h

show_file: cmp di,3840      ;3840=160*24
	   jb noscroll  ;la Nime (=dernire) ligne n'est pas occupe       

	push ds
	
	 mov cx,16
	 mov al,08h
	 mov ah,byte ptr [cs:origine]

scrolle: inc ah
	 mov dx,3d4h
	 out dx,ax

	push ax
	mov dx,3dah
    vbl1: in al,dx
	  test al,8
	  jne vbl1
    vbl2: in al,dx
	   test al,8
	   je vbl2
	pop ax
	
	loop scrolle
	


	push es
	pop ds
	mov si,160
	mov di,0
	mov cx,40*25    ;40*4=160 (dwords) et 25 lignes par cran
	rep movsd       ;Hop on recopie tout,une ligne plus haut


	mov dx,3d4h
	mov al,0ch
	out dx,al
	inc dx
	in al,dx
	mov bh,al
	mov al,0dh
	dec dx
	out dx,al
	inc dx
	in al,dx
	mov bl,al

	sub bx,80

	mov ah,bh       ;Repositionne les registres 0Ch et 0Dh
	mov al,0ch
	mov dx,3d4h
	;out dx,ax
	mov ah,bl
	inc al
	;out dx,ax

	 mov al,08h             ;Repositionne le "Pel panning"  son origine
	 mov ah,byte ptr [cs:origine]
	 mov dx,3d4h
	 out dx,ax




	dec di  ;repositionnement dans le mot
	pop ds


noscroll:       lea si,[cs:new_dta+30]  ;emplacement nom fichier dans DTA
		mov al,07 ;attribut
		mov cx,12
    write:      mov ah,byte ptr [si]
	stosw
	inc si
	loop write
	   add di,6
	   
	   
	   mov ax,word ptr [cs:new_dta+28]  ;Mot fort de la taille de fichier
	   call show_nombre
	   add di,8
	   mov ax,word ptr [cs:new_dta+26]  ;Mot faible (merci untel :( )
	   call show_nombre


     add di,122  ; la ligne 
     
     lea si,[cs:new_dta+31]  ;Ces 5 instructions servent  viter que certains
     xor eax,eax        ;noms de fichiers trop longs empitent sur              
     mov dword ptr [si],eax   ;le nom de fichier suivant
     mov dword ptr [si+4],eax   ;(un fichier=une lettre minimum)
     mov dword ptr [si+8],eax ;et vivement le 128 bits ! Warf warf!!
     

       inc byte ptr [cs:octet]
       mov ah,4fh       ;recherche la prochaine entre du rpertoire
       int 21h
       jnc show_file





      mov dx,curseur
      add dh,octet
      cmp dh,24
      jb @fin
      mov dh,24
      
  @fin: xor bx,bx
	mov ah,2
	mov cx,0D0Eh
	int 10h
      


  mov ax,4c00h
  int 21h     ;Et c'est vraiment la fin !

show_nombre     proc
		mov bx,ax ;sauve
		shr ah,4  ;on commence par la partie 'high' du registre
		add ah,48 ;convertit ascii
		cmp ah,58 ;compris entre 0 et 9 ?
		jb n4     ; OUI -> affiche directement
		add ah,7  ; NON -> correction pour transformer AH en lettre
	   n4:  mov dl,ah
		mov byte ptr [es:di+1],ah
		
		mov ah,bh
		and ah,0fh
		add ah,48
		cmp ah,58
		jb n3
		add ah,7
	   n3:  mov dl,ah
		mov byte ptr [es:di+3],ah
		
		shr al,4        ;On s'occupe maintenant de la partie 'low'
		add al,48
		cmp al,58
		jb n2
		add al,7
	   n2:  mov dl,al
		mov byte ptr [es:di+5],al
		
		mov al,bl
		and al,0fh
		add al,48
		cmp al,58
		jb n1
		add al,7
	   n1:  mov dl,al
		mov byte ptr [es:di+7],al
		ret
show_nombre endp
    




curseur dw 0
octet db 0      ; la longue,trouver des noms de variables, a devient chiant!
origine db 0    ;valeur de dpart pour le Pel-Panning

line_srce dw 160
line_dest dw 0


new_dta  db 128 dup (0) 
file_search db '*.*',0     ;recherche toutes les entres                     

code ends

end
